# exercise

#### Table of Contents

1. [Description](#description)
1. [Setup - The basics of getting started with exercise](#setup)
    * [Setup requirements](#setup-requirements)
    * [Beginning with exercise](#beginning-with-exercise)
1. [Usage - Configuration options and additional functionality](#usage)
1. [Reference - An under-the-hood peek at what the module is doing and how](#reference)
1. [Limitations - OS compatibility, etc.](#limitations)

## Description

This module is a solution for TSE/PSE Exercise

## Setup

### Requirements 

- jfryman-nginx module
- jfryman-selinux module
- puppetlabs-vcsrepo
- Requires SELinux to be disabled on Red Hat Enterprise because the port 8000 has
  already been defined for soundd_port_t

### Beginning with exercise

- A simple usage using only one required parameter:
   if $::operatingsystem == 'RedHat' {
     class { '::selinux':
       mode => 'disabled',
     }
   }    
   class{"nginx": }
   class { 'exercise': url => 'ec2-52-65-181-92.ap-southeast-2.compute.amazonaws.com' }

## Usage

- Using more available options:
   if $::operatingsystem == 'RedHat' {
     class { '::selinux':
       mode => 'disabled',
     }
   }    
   class{"nginx": }
   class { 'exercise': 
     wwwroot     => '/var/www/html',
     url         => 'ec2-52-63-123-244.ap-southeast-2.compute.amazonaws.com',
     repository  => 'https://github.com/puppetlabs/exercise-webpage',
     port        => 8000,
   }  

## Reference

exercise: Handles configuring nginx vhost and pulling files from the remote repository

## Limitations

Supports the following operating systems: Amazon Linux 2016.03, RHEL 7, Ubuntu 14.04 


## Hiera Support

1. Make sure that %{clientcert} datasource is added to your hiera.yaml
2. Create a yaml file named as your ${certname}.yaml. For example ip-10-0-0-109.ap-southeast-2.compute.internal.yaml
4. Define the values for the keys exercise::wwwroot, exercise::url, exercise::repository and exercise::port in your ${certname}.yaml

For example:
exercise::wwwroot: '/var/www/html'
exercise::url: 'ec2-52-63-123-244.ap-southeast-2.compute.amazonaws.com'
exercise::repository: 'https://github.com/puppetlabs/exercise-webpage'
exercise::port: 8000

